/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <stdio.h>
#include "oo7.h"
#include "globals.h"
#include "VarParams.h"
#include "GenParams.h"

#define DUMMYSIZE	1000

// create cnt dummy objects in a collection
void createDummy (int cnt)
{
    int i;
    dbchar* dummy;

    // create cnt dummy objects 
    for (i=0;i<cnt;i++) 
    {
	dummy = new (DummySetCol) dbchar[DUMMYSIZE];
        DummySet.add(dummy);
	if ((i%1000) == 0) 
	{
		E_CommitTransaction();
		E_BeginTransaction();
	}

    }
}

// scan DummySet collection retrieving all the dummy objects
void Purge()
{
     AssocItr* dummyItr;
     dbchar* dummy;
     dbchar c;
     int cnt=0;
	
     dummyItr = new AssocItr(&DummySet);
     dummy = (dbchar*) dummyItr->next();
     while (dummy != NULL)
     {
	cnt++;
        c = dummy[0]; // extract the first character
        dummy = (dbchar*) dummyItr->next();
     }
     printf("number of dummy objects examined = %d\n",cnt);
}
