/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <string.h>
#include <stdio.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"
#include "IntBtree.h"

//////////////////////////////////////////////////////////////////
//
// Query #8 --- value join between Documents and AtomicParts
// on Document.id and AtomicPart.docId.  This is a key - foreign
// key join.  Algorithm is nested loops with index on document id field
//
// The main drawback is that we have no semantics whatsoever for
// this query.
//
//////////////////////////////////////////////////////////////////


extern int	debugMode;

extern void JoinDoNothing(dbint x, dbint y);


//////////////////////////////////////////////////////////////////
//
// Routine to do Query #8
//
//////////////////////////////////////////////////////////////////


int query8()
{
    AtomicPart* ap;
    Document* doc;
    int	apId;

    int count = 0;

    collection_scan<AtomicPart> AtomScan(AtomicPartSet);
    while (ap = AtomScan.next())
    {
	apId = ap->id;
    	doc = (Document*) DocumentIdIdx->lookup(apId);
	if (doc != NULL)
	{
		// found a matching pair of tuples
                if (debugMode) 
        	        printf("In Query8, atomic part %d matches doc %d.\n",
			            ap->id, doc->id);

	        JoinDoNothing(ap->id, doc->id);
	        count++;
    	}
    }
    return count;
}
