/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <E/sm_btree.h>

// a wrapper for E btree classes to slightly simplify the interface

dbclass StringBtIndex {
private:
    str_btree index;

public:
    StringBtIndex(): index(TitleSize) {}
    void insert(char* val, dbvoid* ref);  // insert (value, ref) pair
    dbvoid* lookup(char* val); // look up val, returning ref to object
    dbvoid* remove(char* val); // delete val, returning ref to object
    // bulk load begin and end routines
    BeginBulkLoad() { return index.BeginBulkLoad();};
    EndBulkLoad()   { return index.EndBulkLoad(); };
};
